package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.generated.managed.Receipt;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("PartitionAnchorReceipt")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class PartitionAnchorReceipt implements Marshallable {
	private PartitionAnchor anchor;
	private Receipt rootChainReceipt;

    //
	public PartitionAnchor getAnchor() {
	    return anchor;
	}
	public void setAnchor(final PartitionAnchor value) {
	    this.anchor = value;
	}

	public PartitionAnchorReceipt anchor(final PartitionAnchor value) {
	    setAnchor(value);
	    return this;
	}
	public Receipt getRootChainReceipt() {
	    return rootChainReceipt;
	}
	public void setRootChainReceipt(final Receipt value) {
	    this.rootChainReceipt = value;
	}

	public PartitionAnchorReceipt rootChainReceipt(final Receipt value) {
	    setRootChainReceipt(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.anchor == null)) {
            marshaller.writeValue(1, anchor);
        }
        if (!(this.rootChainReceipt == null)) {
            marshaller.writeValue(2, rootChainReceipt);
        }
        return marshaller.array();
    }
}
